Re: [algogeeks] DISTINCT Permutations ( Not Easy)

2014-01-09 Thread bujji jajala
Hi Nishanth Pandey,
 I got it. If str[end] char is present in
any index between [start, end)  we would have already generated
permutations with str[end] character  in index start. So no need to
generate those permutations again.


Again, Thank you very much for your programn :).

-Thanks,
Bujji


On Thu, Jan 9, 2014 at 3:56 AM, bujji jajala jajalabu...@gmail.com wrote:

 Hi Nishanth Pandey,
  Excellent solution!   It meets all
 requirements in problem!

 One thing I am finding hard to understand is your duplicate functions
 logic.
 code is simple. But reason behind it I am finding hard.

 I would write  it like
 bool duplicate(char str[], int start, int end)
 {   if(start == end)
   return false;

 // Without loop
 if (str[start] == str[end])   /* I would end up generating same
 permutations   for example   abcacd   here swapping a and a would  repeat
 same permutations.  unfortunately this logic is not working well */
   return true;
   return false;
 }


 Why are you skipping if you find element  you want to swap in between
 start and end  indexes in duplicate function?
 Please let me know you intuition.

 -Thanks,
 Bujji




 On Tue, Jan 7, 2014 at 6:08 AM, Nishant Pandey 
 nishant.bits.me...@gmail.com wrote:

 This will help u i guess :

 #include iostream
 #include string.h
 using namespace std;

 void swap(char str[],int m,int n ) {
 char temp=str[m];
 str[m]=str[n];
 str[n]=temp;
 }
 bool duplicate(char str[], int start, int end)
 {   if(start == end)
   return false;
 else
   for(; startend; start++)
 if (str[start] == str[end])
   return true;
   return false;
 }
 void Permute(char str[], int start, int end)
 {
 if(start = end){
   coutstrendl;
   return;
 }
 for(int i=start;i=end;i++)
 {  if(!duplicate(str,start,i))
{
 swap(str,start,i);
 Permute(str,start+1,end);
 swap(str,start,i);
}
 }
 }

 int main()
 {
   char Str[]=aba;
   Permute(Str,0,strlen(Str)-1);
return 0;
 }



 NIshant Pandey
 Cell : 9911258345
 Voice Mail : +91 124 451 2130




 On Tue, Jan 7, 2014 at 4:44 PM, kumar raja rajkumar.cs...@gmail.comwrote:

 This u can do it using the backtracking method. To know how to use
 backtracking refer algorithm design manual by steve skiena.


 On 7 January 2014 03:35, bujji jajala jajalabu...@gmail.com wrote:

 generate all possible DISTINCT permutations of a given string with some
 possible repeated characters. Use as minimal memory as possible.

 if given string contains n characters in total with m  n distinct
 characters each occuring n_1, n_2, n_m times where n_1 + n_2 + ...+ n_m
 = n

 program should generate n! / ( n_1! * n_2! * * n_m!  )  strings.

 Ex:
  aba  is given string

 Output:

 aab
 aba
 baa


 -Thanks,
 Bujji

  --
 You received this message because you are subscribed to the Google
 Groups Algorithm Geeks group.
 To unsubscribe from this group and stop receiving emails from it, send
 an email to algogeeks+unsubscr...@googlegroups.com.


  --
 You received this message because you are subscribed to the Google
 Groups Algorithm Geeks group.
 To unsubscribe from this group and stop receiving emails from it, send
 an email to algogeeks+unsubscr...@googlegroups.com.


  --
 You received this message because you are subscribed to the Google Groups
 Algorithm Geeks group.
 To unsubscribe from this group and stop receiving emails from it, send an
 email to algogeeks+unsubscr...@googlegroups.com.




-- 
You received this message because you are subscribed to the Google Groups 
Algorithm Geeks group.
To unsubscribe from this group and stop receiving emails from it, send an email 
to algogeeks+unsubscr...@googlegroups.com.


Re: [algogeeks] Re: Median Finding in Sorted Arrays

2014-01-09 Thread Don
http://www.geeksforgeeks.org/median-of-two-sorted-arrays-of-different-sizes/

This gives a reasonable solution. However, I would use iteration instead of 
tail recursion.

Don

On Monday, January 6, 2014 4:15:41 AM UTC-5, atul007 wrote:

 @dave : could you provide pseudo code for ur approach
 On 6 Jan 2014 07:39, Dave dave_an...@juno.com javascript: wrote:

 Use a binary search. Assume that you have arrays a[m] and b[n] sorted in 
 ascending order. If a[i] is the kth smallest element, then b[k-i-2] must be 
 smaller than a[i], and b[k-i-1] must be larger (assuming arrays are 
 zero-based). After using a binary search to find the value of i to meet 
 this condition with k = (m+n)/2, you have to determine if a[i] or b[k-i-1] 
 is the final answer. The complexity is O(log m).

 Dave

 On Sunday, January 5, 2014 5:34:12 AM UTC-6, Sanjay Rajpal wrote:

 Hi guys,

 Please help me in finding median of two sorted arrays of length m and n 
 in minimum possible time.


 Thanks,
 Sanjay

  -- 
 You received this message because you are subscribed to the Google Groups 
 Algorithm Geeks group.
 To unsubscribe from this group and stop receiving emails from it, send an 
 email to algogeeks+...@googlegroups.com javascript:.



-- 
You received this message because you are subscribed to the Google Groups 
Algorithm Geeks group.
To unsubscribe from this group and stop receiving emails from it, send an email 
to algogeeks+unsubscr...@googlegroups.com.